import './assets/main.css'

import { createApp } from 'vue'
import pinia from '@/store/index'
import ElementPlus from 'element-plus'
import 'element-plus/dist/index.css'
import App from './App.vue'
import router from './router'
import * as ElementPlusIconsVue from '@element-plus/icons-vue'
import toolClass from '@/assets/js/toolClass'
import MG from '@/assets/js/middleGround/WebMiddleGroundApi.js'
import './child.ts'
import { loginCtx } from '@/assets/js/config.ts'

// 公式输入
import { MathfieldElement } from "mathlive"
// 公式解析
import VueLatex from 'vatex'


const handleGetToken = () => {
  return localStorage.getItem('token')
}

// 路由执行之前的一些操作
router.beforeEach((to, from, next) => {
  console.log(to, from)
  const isInternalLink = from.fullPath.includes('/testBookReader')
  if (isInternalLink) {
    console.log('通过内部链接进入项目')
    sessionStorage.removeItem('loginCtx')
  } else {
    console.log(loginCtx, '通过外部链接进入项目')
    sessionStorage.setItem('loginCtx', loginCtx)
  }

  next()
  // if (handleGetToken()) {
  //   // 是否是登录页面，直接到首页
  //   if (to.path === '/login') {
  //     next({ path: '/home', query: { bookId: localStorage.getItem('bookId') } })
  //   } else {
  //     // 如果不是登录页面，跳转到目标的页面
  //     next()
  //   }
  // } else {
  //   // 没有token
  //   if (!to.meta || !to.meta.auth) {
  //     // 在免登录白名单，直接进入
  //     next()
  //   } else {
  //     next(`/login?redirect=${to.fullPath}`) // 否则全部重定向到登录页
  //   }
  // }
})

// qiankun主应用与微应用通讯
// import { initGlobalState, type MicroAppStateActions } from 'qiankun'
// import state from './qiankunState/state'

// state.bb = (data) => {
//   console.log(data);
// }

// 初始化 state
// const actions: any = initGlobalState(state)

// 监听state变化
// actions.onGlobalStateChange((state: any, prev: any) => {
//   // state: 变更后的状态; prev 变更前的状态
//   console.log("父层change：",state, prev)
// })
// 设置state的值
// actions.setGlobalState(state)

// console.log(actions,"actions");

// app.provide('qiankunActions', actions)
// window.qiankunActions = actions

// 移除当前应用的状态监听，微应用 umount 时会默认调用
// actions.offGlobalStateChange()

const app = createApp(App)


app.provide('toolClass', toolClass)
app.provide('MG', MG)
app.use(VueLatex)
app.use(router)
app.use(ElementPlus)
app.use(pinia)
for (const [key, component] of Object.entries(ElementPlusIconsVue)) {
  app.component(key, component)
}

app.mount('#parentApp')
